'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _formsActionTypes = require('./forms-action-types');

var _formsActionTypes2 = _interopRequireDefault(_formsActionTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  register: function register(formData, formName, formSchema) {
    return {
      type: _formsActionTypes2.default.INIT_FORM,
      payload: { form: formName, data: formData, schema: formSchema }
    };
  },
  clear: function clear(formName) {
    return {
      type: _formsActionTypes2.default.CLEAR_FORM,
      payload: { form: formName, data: {} }
    };
  },
  unregister: function unregister(formName) {
    return {
      type: _formsActionTypes2.default.DELETE_FORM,
      payload: { form: formName }
    };
  },
  updateField: function updateField(fieldName, fieldValue, formName) {
    return {
      type: _formsActionTypes2.default.FORM_FIELD_CHANGE,
      payload: { form: formName, field: fieldName, value: fieldValue }
    };
  },
  addElementToArrayField: function addElementToArrayField(arrayField, valueToAdd, formName) {
    return {
      type: _formsActionTypes2.default.ADD_VALUE_TO_ARRAY_FIELD,
      payload: { form: formName, field: arrayField, value: valueToAdd }
    };
  },
  removeElementFromArrayField: function removeElementFromArrayField(arrayField, index, formName) {
    return {
      type: _formsActionTypes2.default.REMOVE_VALUE_FROM_ARRAY_FIELD,
      payload: { form: formName, field: arrayField, value: index }
    };
  }
};