'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.notifySuccess = notifySuccess;
exports.notifyError = notifyError;
exports.notifyWarning = notifyWarning;
exports.notifyInfo = notifyInfo;
exports.clearNotification = clearNotification;

var _notificationActionTypes = require('./notification-action-types');

var _notificationActionTypes2 = _interopRequireDefault(_notificationActionTypes);

var _notificationTypes = require('./notification-types');

var _notificationTypes2 = _interopRequireDefault(_notificationTypes);

var _cryptoRandomString = require('crypto-random-string');

var _cryptoRandomString2 = _interopRequireDefault(_cryptoRandomString);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function notifySuccess(message) {
  var autoDismiss = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 5;
  var dismissible = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  var position = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 'tr';
  var title = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 'Success';

  var uid = (0, _cryptoRandomString2.default)(10);
  return {
    type: _notificationActionTypes2.default.SHOW_NOTIFICATION,
    payload: {
      level: _notificationTypes2.default.SUCCESS,
      message: message,
      autoDismiss: autoDismiss,
      dismissible: dismissible,
      position: position,
      uid: uid,
      title: title
    }
  };
}
function notifyError(message) {
  var autoDismiss = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 5;
  var dismissible = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  var position = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 'tr';
  var title = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 'Error';

  var uid = (0, _cryptoRandomString2.default)(10);
  return {
    type: _notificationActionTypes2.default.SHOW_NOTIFICATION,
    payload: {
      level: _notificationTypes2.default.ERROR,
      message: message,
      autoDismiss: autoDismiss,
      dismissible: dismissible,
      position: position,
      uid: uid,
      title: title
    }
  };
}

function notifyWarning(message) {
  var autoDismiss = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 5;
  var dismissible = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  var position = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 'tr';
  var title = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 'Warning';

  var uid = (0, _cryptoRandomString2.default)(10);
  return {
    type: _notificationActionTypes2.default.SHOW_NOTIFICATION,
    payload: {
      level: _notificationTypes2.default.WARNING,
      message: message,
      autoDismiss: autoDismiss,
      dismissible: dismissible,
      position: position,
      uid: uid,
      title: title
    }
  };
}

function notifyInfo(message) {
  var autoDismiss = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 5;
  var dismissible = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  var position = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 'tr';
  var title = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 'Information';

  var uid = (0, _cryptoRandomString2.default)(10);
  return {
    type: _notificationActionTypes2.default.SHOW_NOTIFICATION,
    payload: {
      level: _notificationTypes2.default.INFO,
      message: message,
      autoDismiss: autoDismiss,
      dismissible: dismissible,
      position: position,
      uid: uid,
      title: title
    }
  };
}

function clearNotification() {
  return {
    type: _notificationActionTypes2.default.CLEAR_NOTIFICATION,
    payload: {}
  };
}