'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _shallowequal = require('shallowequal');

var _shallowequal2 = _interopRequireDefault(_shallowequal);

var _lodash = require('lodash');

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _formsActionCreators = require('../actions/forms-action-creators');

var _formsActionCreators2 = _interopRequireDefault(_formsActionCreators);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var checkError = function checkError(validationResult) {
  if (!validationResult) {
    return '';
  }

  if (!validationResult.result) {
    return validationResult.error;
  }
  return '';
};

var defaultDataTransform = function defaultDataTransform(data) {
  return data;
};
function composeWithRedux(FormName, formSchema) {
  var dataTransform = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : defaultDataTransform;

  return function (ComposedComponent) {
    var Container = function (_Component) {
      _inherits(Container, _Component);

      function Container() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, Container);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Container.__proto__ || Object.getPrototypeOf(Container)).call.apply(_ref, [this].concat(args))), _this), _this.onChange = function (field, value) {
          var updateField = _this.props.updateField;

          updateField(field, value, FormName);
        }, _temp), _possibleConstructorReturn(_this, _ret);
      }

      _createClass(Container, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          var register = this.props.register;
          /*
          * Here we will first copy the default data
          * then we will copy our props data that is coming
          * from outside onto it and set it inside our form
          * At this moment we are setting the data for
          * the first time.
          */

          var newFormData = {};
          if (this.props.data) {
            (0, _lodash.extend)(newFormData, dataTransform(this.props.data));
          }
          register(newFormData, FormName, formSchema);
        }
      }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(newProps) {
          var register = this.props.register;
          /*
          * Here we are setting the default data first for the form
          * Then we are copying data already in the form onto it.
          * Then we replace new data that is coming from outside
          * onto it if there is any. Then we initialize the form
          * with it. This is not the first time we are setting the data.
          */

          var data = {};
          if (newProps.formData) {
            (0, _lodash.extend)(data, dataTransform(newProps.formData));
            register(data, FormName, formSchema);
          }
        }
      }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
          var shouldUpdate = !(0, _shallowequal2.default)(this.props, nextProps);
          if (this.state && nextState) {
            shouldUpdate = shouldUpdate || !(0, _shallowequal2.default)(this.state.payload, nextState.payload);
          }
          return shouldUpdate;
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          var unregister = this.props.unregister;

          unregister(FormName);
        }

        /*
        onAutoCompleteSelect(field, value) {
          const { FormState } = this.props;
          FormState.formFieldChange(field, value, this.state.formName);
        }*/

      }, {
        key: 'render',
        value: function render() {
          var _this2 = this;

          var schema = formSchema;
          var form = this.props[FormName];
          var newSchema = (0, _lodash.mapValues)(schema, function (field) {
            var valueForUndefinedField = { value: undefined, validationResult: { result: true } };
            var fieldValue = form && form[field.name] ? form[field.name] : valueForUndefinedField;
            return _extends({}, field, {
              onChange: _this2.onChange,
              value: fieldValue.value,
              errorText: checkError(fieldValue.validationResult)
            });
          });

          var formValues = (0, _lodash.mapValues)(schema, function (field) {
            var fieldValue = form && form[field.name] ? form[field.name].value : undefined;
            return fieldValue;
          });

          var formValid = form && form.valid ? form.valid : false;
          return _react2.default.createElement(ComposedComponent, _extends({}, this.props, newSchema, {
            valid: formValid,
            formValues: formValues
          }));
        }
      }]);

      return Container;
    }(_react.Component);

    Container.propTypes = {
      data: _propTypes2.default.object,
      register: _propTypes2.default.func,
      unregister: _propTypes2.default.func,
      updateField: _propTypes2.default.func
    };


    return (0, _reactRedux.connect)(function (state) {
      return state.Forms;
    }, function (dispatch) {
      return (0, _redux.bindActionCreators)(_formsActionCreators2.default, dispatch);
    })(Container);
  };
}

exports.default = composeWithRedux;