'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _AutoComplete = require('material-ui/AutoComplete');

var _AutoComplete2 = _interopRequireDefault(_AutoComplete);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AutoCompleteDataField = function (_Component) {
  _inherits(AutoCompleteDataField, _Component);

  function AutoCompleteDataField() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, AutoCompleteDataField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = AutoCompleteDataField.__proto__ || Object.getPrototypeOf(AutoCompleteDataField)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      list: []
    }, _this.onNewRequest = function (chosenRequest) {
      _this.props.onChange(_this.props.name, chosenRequest);
    }, _this.onTextChange = function (textFieldValue) {
      var _this$props = _this.props,
          name = _this$props.name,
          onChange = _this$props.onChange;

      _this.setState({
        selectedItem: textFieldValue
      });
      if (onChange) {
        onChange(name, textFieldValue);
      }
      _this.searchInDataSource(textFieldValue);
    }, _this.searchInDataSource = function (inputValue) {
      var _this$props2 = _this.props,
          dataSource = _this$props2.dataSource,
          dataSourceConfig = _this$props2.dataSourceConfig;

      function criteria(element) {
        var expr = new RegExp('.*' + inputValue.toUpperCase() + '.*', 'i');
        return element[dataSourceConfig.text].toUpperCase().search(expr) >= 0;
      }
      if (inputValue) {
        var updatedList = dataSource.filter(criteria);
        var updatedLimitedList = updatedList.slice(0, 5);
        _this.setState({ list: updatedLimitedList });
      }
    }, _this.handleUpdateInput = function (inputValue) {
      _this.onTextChange(inputValue);
    }, _this.handleBlur = function () {
      var _this$props3 = _this.props,
          name = _this$props3.name,
          dataSourceConfig = _this$props3.dataSourceConfig,
          onChange = _this$props3.onChange;
      var list = _this.state.list;

      if (list.length === 0) {
        _this.onTextChange(null);
        return;
      }
      var selectedValue = _this.state.selectedItem;

      if (selectedValue && list[0]) {
        selectedValue = dataSourceConfig ? list[0] : list[0][name];
      }
      onChange(name, selectedValue);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(AutoCompleteDataField, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          dataSource = _props.dataSource,
          dataSourceConfig = _props.dataSourceConfig,
          errorText = _props.errorText,
          labelText = _props.labelText,
          name = _props.name,
          filter = _props.filter,
          value = _props.value,
          displayField = _props.displayField,
          disabled = _props.disabled;

      var searchText = value;
      var list = this.state.list;

      if (dataSourceConfig) {
        searchText = value ? value[dataSourceConfig.text] : '';
      } else if (value != null && (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object' && displayField) {
        searchText = value[displayField];
      }
      return _react2.default.createElement(_AutoComplete2.default, {
        disabled: disabled || false,
        searchText: searchText,
        dataSource: list || dataSource,
        dataSourceConfig: dataSourceConfig,
        errorText: errorText,
        floatingLabelText: labelText,
        fullWidth: true,
        name: name,
        filter: filter,
        onNewRequest: this.onNewRequest,
        onUpdateInput: this.handleUpdateInput,
        onBlur: this.handleBlur
      });
    }
  }]);

  return AutoCompleteDataField;
}(_react.Component);

AutoCompleteDataField.propTypes = {
  dataSource: _propTypes2.default.array,
  dataSourceConfig: _propTypes2.default.object,
  displayField: _propTypes2.default.string,
  errorText: _propTypes2.default.node,
  labelText: _propTypes2.default.string,
  fullWidth: _propTypes2.default.bool,
  name: _propTypes2.default.string,
  filter: _propTypes2.default.func,
  value: _propTypes2.default.any,
  onChange: _propTypes2.default.func,
  disabled: _propTypes2.default.bool
};
exports.default = AutoCompleteDataField;