'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _timeDataField = require('./time-data-field');

var _timeDataField2 = _interopRequireDefault(_timeDataField);

var _textDataField = require('./text-data-field');

var _textDataField2 = _interopRequireDefault(_textDataField);

var _dateDataField = require('./date-data-field');

var _dateDataField2 = _interopRequireDefault(_dateDataField);

var _checkboxDataField = require('./checkbox-data-field');

var _checkboxDataField2 = _interopRequireDefault(_checkboxDataField);

var _selectDataField = require('./select-data-field');

var _selectDataField2 = _interopRequireDefault(_selectDataField);

var _filteredSelectDataFields = require('./filtered-select-data-fields');

var _filteredSelectDataFields2 = _interopRequireDefault(_filteredSelectDataFields);

var _passwordDataField = require('./password-data-field');

var _passwordDataField2 = _interopRequireDefault(_passwordDataField);

var _formulaDataField = require('./formula-data-field');

var _formulaDataField2 = _interopRequireDefault(_formulaDataField);

var _numberDataField = require('./number-data-field');

var _numberDataField2 = _interopRequireDefault(_numberDataField);

var _readOnlyTextField = require('./read-only-text-field');

var _readOnlyTextField2 = _interopRequireDefault(_readOnlyTextField);

var _toggleDataField = require('./toggle-data-field');

var _toggleDataField2 = _interopRequireDefault(_toggleDataField);

var _autocompleteDataField = require('./autocomplete-data-field');

var _autocompleteDataField2 = _interopRequireDefault(_autocompleteDataField);

var _fieldType = require('../field-type');

var _fieldType2 = _interopRequireDefault(_fieldType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DataField = function (_Component) {
  _inherits(DataField, _Component);

  function DataField() {
    _classCallCheck(this, DataField);

    return _possibleConstructorReturn(this, (DataField.__proto__ || Object.getPrototypeOf(DataField)).apply(this, arguments));
  }

  _createClass(DataField, [{
    key: 'getType',
    value: function getType() {
      if (this.props.type) {
        return this.props.type;
      }
      return _fieldType2.default.ReadOnly;
    }
  }, {
    key: 'createAutoCompleteComponent',
    value: function createAutoCompleteComponent() {
      return _react2.default.createElement(_autocompleteDataField2.default, this.props);
    }
  }, {
    key: 'createToggleComponent',
    value: function createToggleComponent() {
      return _react2.default.createElement(_toggleDataField2.default, this.props);
    }
  }, {
    key: 'createReadOnlyDataField',
    value: function createReadOnlyDataField() {
      return _react2.default.createElement(_readOnlyTextField2.default, this.props);
    }
  }, {
    key: 'createDateComponent',
    value: function createDateComponent() {
      var value = new Date(this.props.value);
      return _react2.default.createElement(_dateDataField2.default, _extends({ value: value }, this.props));
    }
  }, {
    key: 'createTextComponent',
    value: function createTextComponent() {
      return _react2.default.createElement(_textDataField2.default, this.props);
    }
  }, {
    key: 'createNumberDataField',
    value: function createNumberDataField() {
      return _react2.default.createElement(_numberDataField2.default, this.props);
    }
  }, {
    key: 'createTimeComponent',
    value: function createTimeComponent() {
      var value = new Date(this.props.value);
      return _react2.default.createElement(_timeDataField2.default, _extends({ value: value }, this.props));
    }
  }, {
    key: 'createCheckboxComponent',
    value: function createCheckboxComponent() {
      return _react2.default.createElement(_checkboxDataField2.default, this.props);
    }
  }, {
    key: 'createSelectComponent',
    value: function createSelectComponent() {
      return _react2.default.createElement(_selectDataField2.default, this.props);
    }
  }, {
    key: 'createFilterSelectComponent',
    value: function createFilterSelectComponent() {
      return _react2.default.createElement(_filteredSelectDataFields2.default, this.props);
    }
  }, {
    key: 'createPasswordComponent',
    value: function createPasswordComponent() {
      return _react2.default.createElement(_passwordDataField2.default, this.props);
    }
  }, {
    key: 'createFormulaComponent',
    value: function createFormulaComponent() {
      return _react2.default.createElement(_formulaDataField2.default, this.props);
    }
  }, {
    key: 'createField',
    value: function createField() {
      var type = this.getType();
      switch ((0, _lodash.toUpper)(type)) {
        case _fieldType2.default.AutoComplete:
          return this.createAutoCompleteComponent();
        case _fieldType2.default.Date:
          return this.createDateComponent();
        case _fieldType2.default.Time:
          return this.createTimeComponent();
        case _fieldType2.default.Bool:
          return this.createCheckboxComponent();
        case _fieldType2.default.Select:
          return this.createSelectComponent();
        case _fieldType2.default.FilterSelect:
          return this.createFilterSelectComponent();
        case _fieldType2.default.Password:
          return this.createPasswordComponent();
        case _fieldType2.default.Formula:
          return this.createFormulaComponent();
        case _fieldType2.default.Number:
          return this.createNumberDataField();
        case _fieldType2.default.Text:
          return this.createTextComponent();
        case _fieldType2.default.Toggle:
          return this.createToggleComponent();
        default:
          return this.createReadOnlyDataField();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        null,
        this.createField()
      );
    }
  }]);

  return DataField;
}(_react.Component);

exports.default = DataField;


DataField.propTypes = {
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.bool, _propTypes2.default.number, _propTypes2.default.object, _propTypes2.default.array]),
  type: _propTypes2.default.string
};