'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DatePicker = require('material-ui/DatePicker');

var _DatePicker2 = _interopRequireDefault(_DatePicker);

var _util = require('../util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DateDataField = function (_Component) {
  _inherits(DateDataField, _Component);

  function DateDataField() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, DateDataField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DateDataField.__proto__ || Object.getPrototypeOf(DateDataField)).call.apply(_ref, [this].concat(args))), _this), _this.onDateChanged = function (event, newDate) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          name = _this$props.name;

      onChange(name, newDate);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(DateDataField, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.value,
          labelText = _props.labelText,
          DateTimeFormat = _props.DateTimeFormat,
          autoOk = _props.autoOk,
          cancelLabel = _props.cancelLabel,
          className = _props.className,
          container = _props.container,
          dialogContainerStyle = _props.dialogContainerStyle,
          disableYearSelection = _props.disableYearSelection,
          disabled = _props.disabled,
          errorText = _props.errorText,
          firstDayOfWeek = _props.firstDayOfWeek,
          formatDate = _props.formatDate,
          locale = _props.locale,
          maxDate = _props.maxDate,
          minDate = _props.minDate,
          mode = _props.mode,
          okLabel = _props.okLabel,
          onDismiss = _props.onDismiss,
          onFocus = _props.onFocus,
          onShow = _props.onShow,
          onTouchTap = _props.onTouchTap,
          shouldDisableDate = _props.shouldDisableDate,
          style = _props.style,
          textFieldStyle = _props.textFieldStyle;


      var newProps = {
        floatingLabelText: labelText,
        autoOk: autoOk || false,
        className: className || '',
        disabled: disabled || false,
        firstDayOfWeek: firstDayOfWeek || 1,
        mode: mode || 'portrait',
        onChange: this.onDateChanged,
        dialogContainerStyle: dialogContainerStyle,
        disableYearSelection: disableYearSelection,
        errorText: errorText,
        maxDate: maxDate,
        minDate: minDate,
        okLabel: okLabel,
        onDismiss: onDismiss,
        onFocus: onFocus,
        onShow: onShow,
        onTouchTap: onTouchTap,
        shouldDisableDate: shouldDisableDate,
        style: style,
        textFieldStyle: textFieldStyle,
        fullWidth: true
      };

      if (!(0, _util.isNullOrUndefined)(DateTimeFormat)) {
        newProps.DateTimeFormat = DateTimeFormat;
      }

      if (!(0, _util.isNullOrUndefined)(cancelLabel)) {
        newProps.cancelLabel = cancelLabel;
      }

      if (!(0, _util.isNullOrUndefined)(container)) {
        newProps.container = container;
      }

      if ((0, _util.isDefined)(formatDate)) {
        newProps.formatDate = formatDate;
      }

      if ((0, _util.isDefined)(locale)) {
        newProps.locale = locale;
      }

      if ((0, _util.isDefined)(value)) {
        newProps.value = value;
      }

      return _react2.default.createElement(_DatePicker2.default, newProps);
    }
  }]);

  return DateDataField;
}(_react.Component);

DateDataField.propTypes = {
  labelText: _propTypes2.default.string,
  value: _propTypes2.default.object,
  name: _propTypes2.default.string,
  onChange: _propTypes2.default.func,

  DateTimeFormat: _propTypes2.default.func,
  autoOk: _propTypes2.default.func,
  cancelLabel: _propTypes2.default.node,
  className: _propTypes2.default.string,
  container: _propTypes2.default.string,
  defaultDate: _propTypes2.default.object,
  dialogContainerStyle: _propTypes2.default.object,
  disableYearSelection: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  errorText: _propTypes2.default.string,
  firstDayOfWeek: _propTypes2.default.number,
  formatDate: _propTypes2.default.func,
  locale: _propTypes2.default.string,

  maxDate: _propTypes2.default.object,
  minDate: _propTypes2.default.object,
  mode: _propTypes2.default.string,
  okLabel: _propTypes2.default.node,
  onDismiss: _propTypes2.default.func,
  onFocus: _propTypes2.default.func,
  onShow: _propTypes2.default.func,
  onTouchTap: _propTypes2.default.func,
  shouldDisableDate: _propTypes2.default.func,
  style: _propTypes2.default.object,

  textFieldStyle: _propTypes2.default.object
};
exports.default = DateDataField;