'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _selectDataField = require('./select-data-field');

var _selectDataField2 = _interopRequireDefault(_selectDataField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var FilteredSelectDataField = function FilteredSelectDataField(props) {
  var initialArray = props.initialArray,
      filterArray = props.filterArray,
      filterFunction = props.filterFunction,
      other = _objectWithoutProperties(props, ['initialArray', 'filterArray', 'filterFunction']);

  var filteredArray = (0, _lodash.differenceWith)(initialArray, filterArray, filterFunction);
  return _react2.default.createElement(_selectDataField2.default, _extends({}, other, { menuItems: filteredArray }));
};

FilteredSelectDataField.propTypes = {
  initialArray: _propTypes2.default.array,
  filterArray: _propTypes2.default.array,
  filterFunction: _propTypes2.default.func
};

exports.default = FilteredSelectDataField;