'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _SelectField = require('material-ui/SelectField');

var _SelectField2 = _interopRequireDefault(_SelectField);

var _MenuItem = require('material-ui/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SelectDataField = function (_Component) {
  _inherits(SelectDataField, _Component);

  function SelectDataField() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, SelectDataField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = SelectDataField.__proto__ || Object.getPrototypeOf(SelectDataField)).call.apply(_ref, [this].concat(args))), _this), _this.handleChange = function (event, selectedIndex, value) {
      event.preventDefault();
      _this.props.onChange(_this.props.name, value);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(SelectDataField, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.value,
          name = _props.name,
          dataSource = _props.dataSource,
          dataSourceConfig = _props.dataSourceConfig,
          labelText = _props.labelText,
          errorText = _props.errorText,
          disabled = _props.disabled,
          style = _props.style,
          multiple = _props.multiple;

      var menu = null;
      if (dataSourceConfig) {
        var index = 0;
        menu = dataSource.map(function (item) {
          var menuItemProps = {};
          menuItemProps.value = dataSourceConfig.valueKey ? item[dataSourceConfig.valueKey] : item;
          menuItemProps.primaryText = item[dataSourceConfig.primaryTextKey];
          index += 1;
          menuItemProps.key = index;
          if (dataSourceConfig.secondaryTextKey) {
            menuItemProps.secondaryText = item[dataSourceConfig.secondaryTextKey];
          }
          return _react2.default.createElement(_MenuItem2.default, menuItemProps);
        });
      } else {
        var _index = 0;
        menu = dataSource.map(function (item) {
          var menuItemProps = {};
          _index += 1;
          menuItemProps.value = item;
          menuItemProps.primaryText = item;
          menuItemProps.key = _index;
          return _react2.default.createElement(_MenuItem2.default, menuItemProps);
        });
      }
      var newProps = {
        value: value,
        name: name,
        floatingLabelText: labelText,
        errorText: errorText,
        disabled: disabled,
        fullWidth: true,
        onChange: this.handleChange,
        style: style,
        multiple: multiple || false
      };

      return _react2.default.createElement(
        _SelectField2.default,
        newProps,
        menu
      );
    }
  }]);

  return SelectDataField;
}(_react.Component);

SelectDataField.propTypes = {
  value: _propTypes2.default.any,
  onChange: _propTypes2.default.func,
  errorText: _propTypes2.default.node,
  dataSource: _propTypes2.default.array,
  dataSourceConfig: _propTypes2.default.object,
  name: _propTypes2.default.string,
  labelText: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  style: _propTypes2.default.object,
  multiple: _propTypes2.default.bool
};
exports.default = SelectDataField;