'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextDataField = function (_Component) {
  _inherits(TextDataField, _Component);

  function TextDataField() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TextDataField);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TextDataField.__proto__ || Object.getPrototypeOf(TextDataField)).call.apply(_ref, [this].concat(args))), _this), _this.onBlur = function (event) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          name = _this$props.name,
          onBlurred = _this$props.onBlurred;

      var textFieldValue = (0, _lodash.trim)(event.target.value);
      if (onBlurred) {
        onBlurred(name, textFieldValue);
        return;
      }
      onChange(name, textFieldValue);
    }, _this.onTextChange = function (event, newValue) {
      event.preventDefault();
      var _this$props2 = _this.props,
          onChange = _this$props2.onChange,
          name = _this$props2.name;

      var textFieldValue = newValue;
      onChange(name, textFieldValue);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TextDataField, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          defaultValue = _props.defaultValue,
          disabled = _props.disabled,
          errorText = _props.errorText,
          errorStyle = _props.errorStyle,
          floatingLabelFixed = _props.floatingLabelFixed,
          floatingLabelStyle = _props.floatingLabelStyle,
          fullWidth = _props.fullWidth,
          hintStyle = _props.hintStyle,
          hintText = _props.hintText,
          id = _props.id,
          inputStyle = _props.inputStyle,
          labelText = _props.labelText,
          multiLine = _props.multiLine,
          name = _props.name,
          rows = _props.rows,
          rowsMax = _props.rowsMax,
          type = _props.type,
          value = _props.value;


      var newProps = {
        className: className,
        disabled: disabled,
        errorText: errorText,
        errorStyle: errorStyle,
        floatingLabelText: labelText,
        floatingLabelFixed: floatingLabelFixed,
        floatingLabelStyle: floatingLabelStyle,
        fullWidth: true,
        hintStyle: hintStyle,
        hintText: hintText,
        id: id,
        inputStyle: inputStyle,
        multiLine: multiLine,
        name: name,
        onChange: this.onTextChange,
        onBlur: this.onBlur,
        rows: rows,
        rowsMax: rowsMax,
        type: type,
        value: value
      };

      return _react2.default.createElement(_TextField2.default, newProps);
    }
  }]);

  return TextDataField;
}(_react.Component);

TextDataField.propTypes = {
  className: _propTypes2.default.string,
  defaultValue: _propTypes2.default.any,
  disabled: _propTypes2.default.bool,
  errorText: _propTypes2.default.string,
  errorStyle: _propTypes2.default.object,
  floatingLabelFixed: _propTypes2.default.bool,
  floatingLabelStyle: _propTypes2.default.object,
  fullWidth: _propTypes2.default.bool,
  hintStyle: _propTypes2.default.object,
  hintText: _propTypes2.default.node,
  id: _propTypes2.default.string,
  inputStyle: _propTypes2.default.string,
  labelText: _propTypes2.default.string,
  multiLine: _propTypes2.default.bool,
  name: _propTypes2.default.string,
  onChange: _propTypes2.default.func,
  onBlurred: _propTypes2.default.func,
  rows: _propTypes2.default.number,
  rowsMax: _propTypes2.default.number,
  type: _propTypes2.default.string,
  value: _propTypes2.default.any
};
exports.default = TextDataField;