'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dataTypes = require('../data-types');

var _dataTypes2 = _interopRequireDefault(_dataTypes);

var _fieldType = require('../field-type');

var _fieldType2 = _interopRequireDefault(_fieldType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TextFieldSchema = function () {
  function TextFieldSchema(name) {
    _classCallCheck(this, TextFieldSchema);

    this.name = name;
    this.fieldType = _dataTypes2.default.String;
    this.type = _fieldType2.default.Text;
    this.isRequired = false;
    this.disabled = false;
    this.defaultValue = '';
  }

  _createClass(TextFieldSchema, [{
    key: 'readOnly',
    value: function readOnly() {
      this.disabled = true;
      return this;
    }
  }, {
    key: 'password',
    value: function password() {
      this.type = _fieldType2.default.Password;
      return this;
    }
  }, {
    key: 'default',
    value: function _default(defaultValue) {
      this.defaultValue = defaultValue;
      return this;
    }
  }, {
    key: 'mandatory',
    value: function mandatory() {
      this.isRequired = true;
      return this;
    }
  }, {
    key: 'label',
    value: function label(labelText) {
      this.labelText = labelText;
      return this;
    }
  }, {
    key: 'regex',
    value: function regex(validationRegex) {
      this.validationRegex = validationRegex;
      return this;
    }
  }]);

  return TextFieldSchema;
}();

exports.default = TextFieldSchema;